#
# spec file for package squid (Version 2.4.STABLE7)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  cyrus-sasl openldap2 openldap2-client openldap2-devel openssl openssl-devel sgmltool sharutils sp sp-devel tetex
# usedforbuild    aaa_base aaa_version acl attr bash bind9-utils bison cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fileutils fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip kbd less libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail sh-utils shadow strace syslogd sysvinit tar texinfo textutils timezone unzip util-linux vim zlib-devel autoconf automake binutils bzip2 cracklib gcc gdbm gettext heimdal-lib libtool openldap2 openldap2-client openldap2-devel openssl openssl-devel perl rpm sgmltool sharutils sp sp-devel te_ams te_latex tetex zlib

Name:         squid
Summary:      Squid WWW proxy server
Version:      2.4.STABLE7
Release:      288
License:      GPL
URL:          http://www.squid-cache.org
Group:        Productivity/Networking/Web/Proxy
Requires:     logrotate
Provides:     http_proxy
Conflicts:    squid-beta squid2 squid23
Autoreqprov:  on
%if %suse_version > 800
PreReq:       /usr/sbin/useradd, %insserv_prereq, %fillup_prereq
%endif
Source:       squid-%{version}-src.tar.bz2
%define       squid_ldapauth_version 1.3
Source1:      squid_ldapauth-%{squid_ldapauth_version}.tar.bz2
Source2:      rc.squid
Source4:      README.SuSE
Source5:      pam.squid
Source6:      squid.logrotate
#Source21:     msntauth-v2.0.3-squid.1.tar.gz
Patch:        squid-2.4.STABLE2.dif
Patch1:       squid_ldapauth-%{squid_ldapauth_version}.dif
patch2:	      http://www.squid-cache.org/Versions/v2/2.4/bugs/squid-2.4.STABLE7-msntauth.patch
Patch3:       http://www.squid-cache.org/Versions/v2/2.5/bugs/squid-2.5.STABLE6-SNMP_core_dump.patch
Patch4:       http://www.squid-cache.org/Versions/v2/2.5/bugs/squid-2.5.STABLE7-gopher_html_parsing.patch
Patch5:       squid-2.4.STABLE7-wccp_denial_of_service.patch
Patch6:       squid-2.4.STABLE7-ldap_spaces.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
%define		squidconfdir /etc/squid

%description
The stable version of the Squid WWW Proxy Server

Home page: http://www.squid-cache.org

Authors:
--------
    Duane Wessels <wessels@ircache.net>

%prep
%setup -n squid-%{version} -a 1
#(cd auth_modules
#tar xzf %{S:21} 
#rm -r MSNT
#mv msntauth-v2.0.3-squid.1 MSNT
#)
%patch -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
perl -pi -e 's%^#!/usr/local/bin/perl%#!/usr/bin/perl%g' `find -name "*.pl"`
perl -pi -e 's/(?<!DESTDIR\))\$\(bindir\)/\$\(DESTDIR\)\$\(bindir\)/g' `find -name "*.in"`
perl -pi -e 's/(?<!DESTDIR\))\$\(datadir\)/\$\(DESTDIR\)\$\(datadir\)/g' `find -name "*.in"`
perl -pi -e 's/(?<!DESTDIR\))\$\(execprefix\)/\$\(DESTDIR\)\$\(execprefix\)/g' `find -name "*.in"`
perl -pi -e 's/(?<!DESTDIR\))\$\(libexecdir\)/\$\(DESTDIR\)\$\(libexecdir\)/g' `find -name "*.in"`
perl -pi -e 's/(?<!DESTDIR\))\$\(localstatedir\)/\$\(DESTDIR\)\$\(localstatedir\)/g' `find -name "*.in"`
perl -pi -e 's/(?<!DESTDIR\))\$\(sysconfdir\)/\$\(DESTDIR\)\$\(sysconfdir\)/g' `find -name "*.in"`
(cd squid_ldapauth*
%patch1
)

%build
CFLAGS='-Wall -O2 -pipe'
LDFLAGS=' '
ulimit -n 4096
./configure --prefix=/usr \
	--sysconfdir=%{squidconfdir} \
	--bindir=/usr/sbin \
	--sbindir=/usr/sbin \
	--localstatedir=/var \
	--libexecdir=/usr/sbin \
	--datadir=/usr/share/squid \
	--enable-snmp \
	--enable-useragent-log \
	--enable-auth-modules="LDAP NCSA PAM SMB MSNT YP getpwnam" \
	--enable-referer-log \
	--enable-arp-acl \
	--enable-htcp \
	--enable-underscores \
	--enable-stacktraces \
	--enable-delay-pools
#--enable-linux-netfilter # linux 2.4
make 	 DEFAULT_CACHE_LOG=/var/log/squid/cache.log \
	DEFAULT_ACCESS_LOG=/var/log/squid/access.log \
	 DEFAULT_STORE_LOG=/var/log/squid/store.log \
	  DEFAULT_SWAP_DIR=/var/cache/squid \
	  DEFAULT_PID_FILE=/var/run/squid.pid
make -C squid_ldapauth-%{squid_ldapauth_version}
#make -C auth_modules/PAM
#make -C auth_modules/NCSA
#make -C auth_modules/YP
##make -C doc/Programming-Guide

%install
/usr/sbin/useradd -r -o -g nogroup -u 31 -s /bin/false -c "WWW-proxy squid" -d /var/cache/squid squid 2> /dev/null || :
mkdir -p $RPM_BUILD_ROOT/var/{cache,log}/squid
mkdir -p $RPM_BUILD_ROOT/usr/sbin
make install DESTDIR=$RPM_BUILD_ROOT
#make install DESTDIR=$RPM_BUILD_ROOT -C auth_modules/PAM
#make install DESTDIR=$RPM_BUILD_ROOT -C auth_modules/NCSA
#make install DESTDIR=$RPM_BUILD_ROOT MAKE="make DESTDIR=$RPM_BUILD_ROOT" -C auth_modules/YP
install -d -m 755 $RPM_BUILD_ROOT/etc/logrotate.d
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT/etc/logrotate.d/squid
install -d %{buildroot}%{_mandir}/man8/
chown squid.root -R $RPM_BUILD_ROOT/var/{cache,log}/squid
chmod 750 $RPM_BUILD_ROOT/var/{cache,log}/squid
install -D %{SOURCE2} $RPM_BUILD_ROOT/etc/init.d/squid
ln -sf /etc/init.d/squid $RPM_BUILD_ROOT/usr/sbin/rcsquid
install -d -m 755 doc/scripts
install scripts/*.pl doc/scripts
mv $RPM_BUILD_ROOT/usr/sbin/cachemgr.cgi doc/scripts
install -d -m 755 doc/contrib
install contrib/*.pl doc/contrib
#rm doc/Programming-Guide/Makefile
install -m 644 %{SOURCE4} .
install -D -m 644 %{SOURCE5} $RPM_BUILD_ROOT/etc/pam.d/squid
chown squid.shadow $RPM_BUILD_ROOT/usr/sbin/pam_auth
chmod g+s $RPM_BUILD_ROOT/usr/sbin/pam_auth
cd squid_ldapauth-%{squid_ldapauth_version}
install -m 750 -osquid -groot squid_ldapauth $RPM_BUILD_ROOT/usr/sbin/
cp README ../README.squid_ldapauth
cp CREDITS ../CREDITS.squid_ldapauth
cp squid_ldapauth.conf ..
rm %{buildroot}/usr/sbin/Run*
rm -rf %{buildroot}%{squidconfdir}/errors
for i in errors/*; do
	if [ -d $i ]; then
		mkdir -p %{buildroot}/usr/share/squid/$i
		install -m 644 $i/* %{buildroot}/usr/share/squid/$i
	fi
done
ln -fs /usr/share/squid/errors/English %{buildroot}%{squidconfdir}/errors

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/useradd -r -o -g nogroup -u 31 -s /bin/false -c "WWW-proxy squid" -d /var/cache/squid squid 2> /dev/null || :

%post
# update mode?
if [ $1 -gt 1 ]; then
	if [ -e etc/squid.conf -a ! -L etc/squid.conf -a ! -e etc/squid/squid.conf ]; then
		echo "moving /etc/squid.conf to /etc/squid/squid.conf"
		mv etc/squid.conf etc/squid/squid.conf
	fi
fi
%{fillup_and_insserv squid}

%postun
%{insserv_cleanup}

%files
%defattr(-,root,root)
%attr(750,squid,root) %dir /var/cache/squid
%attr(750,squid,root) %dir /var/log/squid
%dir %{squidconfdir}
%config(noreplace) %{squidconfdir}/squid.conf
%config(noreplace) %{squidconfdir}/errors
%{squidconfdir}/squid.conf.default
%config(noreplace) /etc/logrotate.d/squid
%config /etc/pam.d/squid
%config /etc/init.d/squid
%dir /usr/share/squid
/usr/share/squid/errors
/usr/share/squid/icons
%config /usr/share/squid/mib.txt
%config /usr/share/squid/mime.conf
/usr/share/squid/mime.conf.default
/usr/sbin/[a-rt-z]*
/usr/sbin/smb_auth*
/usr/sbin/squid
/usr/sbin/squid_ldap_auth
%attr(750,squid,root) /usr/sbin/squid_ldapauth
%doc CONTRIBUTORS COPYING COPYRIGHT CREDITS
%doc ChangeLog QUICKSTART README README.SuSE TODO
%doc doc/HTTP-codes.txt doc/draft-vixie-htcp-proto-04.txt
%doc doc/contrib doc/scripts doc/Programming-Guide 
%doc errors doc/debug-sections.txt src/squid.conf
%doc README.squid_ldapauth CREDITS.squid_ldapauth
%doc squid_ldapauth.conf

%changelog -n squid
* Wed Jan 26 2005 - kssingvo@suse.de
- fixed gopher_html_parsing issue CAN-2005-0094 (bugzilla#50023)
- fixed wccp_denial_of_service issue CAN-2005-0095 (bugzilla#50023)
- not affected: CAN-2005-0096, CAN-2005-0097
- fixed ldap_spaces security problem (bugzilla#50023)
- not affected: response_splitting and header_parsing (bugzilla#50023)
* Mon Dec 20 2004 - mmj@suse.de
- Remove patch hunk for FS_SETSIZE issues [#49288]
* Thu Oct 14 2004 - kssingvo@suse.de
- fix for remote DoS in snmp module CAN-2004-0918 (bugzilla#47198)
* Thu Jun 26 2003 - kssingvo@suse.de
- fixed wrong ownership of /usr/sbin/squid_ldapauth (reported by mc)
* Tue Sep 03 2002 - kssingvo@suse.de
- fixed pathes in squid.logrotate (bugzilla#18792)
* Mon Aug 05 2002 - kssingvo@suse.de
- added official msnt_auth patch
- added test for suse_version to be backward compatible with PreReq:
* Wed Jul 31 2002 - kssingvo@suse.de
- fixed spec file: new PreReq tokens
- fixed spec file: file permission for cache_dir and log_dir
- fixed rc script: now honors cache_dir in squid.conf and fails if
  problems in creation (bugzilla #14892)
* Mon Jul 29 2002 - kssingvo@suse.de
- fixed Requires/Provides in SPEC file.
* Mon Jul 29 2002 - kssingvo@suse.de
- added useful configure options
- added a lot of new authentification methods (and therefore conflicts
  with RPM smb_auth)
- re-organized %%Files section
* Fri Jul 26 2002 - kssingvo@suse.de
- created /etc/logrotate.d/squid
* Sun Jul 14 2002 - poeml@suse.de
- update to patchlevel 2.4STABLE7 (dropping the respective patches)
- rc.squid INIT section: use X-UnitedLinux-Should-Start
- move configuration to /etc/squid
- install error message files to /usr/share/squid. Link to English
  as default.
- drop %%pre script that renamed /usr/share/squid/errors
- use %%defattr
* Wed Jul 03 2002 - ro@suse.de
- create squid user also at begin of install section
* Tue Jul 02 2002 - poeml@suse.de
- squid does not need a valid login shell.
* Tue Jul 02 2002 - poeml@suse.de
- Update to 2.4.STABLE6 (dropping the last two patches), and add
  several new security fixes (see
  http://www.squid-cache.org/Versions/v2/2.4/bugs/):
  * Buffer overflows in the Gopher client
  * Sanity checks of the FTP data channel
  * FTP directory parsing buffer overflows
  * Make Squid deny transfer-encoding to work around Apache issue
  * Insecure forwarding of proxy_auth
  and minor fixes:
  * cache_mem documentation
  * client -T not implemented
  * HTCP coredump on "squid -k reconfigure"
  Not included, because the module is not activated:
  * Buffer overflows in the MSNT auth helper (updating the module
  from 1.2 to 2.0)
- Using useradd in the specfile.
* Thu Mar 21 2002 - draht@suse.de
- squid-2.4.STABLE3-rfc1035-security.diff fixes compressed dns
  reply buffer overflow.
* Mon Feb 25 2002 - poeml@suse.de
- disable HTCP support (upon recommendation of Henrik Nordstrom
  <hno@squid-cache.org>). The implementation lacks access control
  and logging, and does not add any value to cache peering compared
  to ICP.
* Sat Feb 23 2002 - poeml@suse.de
- test for correct cache directory in rc.squid
- specify DEFAULT_PID_FILE
* Tue Feb 19 2002 - draht@suse.de
- added three security-relevant patches, combined in
  squid-2.4.STABLE3-misc-sec.dif:
  * "htcp port 0" fails to disable the HTCP port
  * coredump on ftp:// style URLs
  * fix for SNMP memory leaks
  See http://www.squid-cache.org/Versions/v2/2.4/bugs/.
* Mon Feb 18 2002 - poeml@suse.de
- update to 2.4.STABLE3: numerous bug fixes. for the Changelog see
  http://www.squid-cache.org/Versions/v2/2.4/ChangeLog.txt
- make file locations more FHS conform:
  /var/squid/cache --> /var/cache/squid
  /var/squid/logs --> /var/log/squid
- drop security patch (included upstream)
* Sat Feb 02 2002 - poeml@suse.de
- replace GmbH --> AG
* Fri Dec 14 2001 - ro@suse.de
- removed START_SQUID
* Fri Oct 05 2001 - bjacke@suse.de
- update to 2.4RC2 (prev. squid-beta package)
- use buildroot
- fix security hole where squid could be crashed by certain requests
* Tue Sep 04 2001 - bodammer@suse.de
- specfile fix: install /etc/squid.conf with noreplace [Bug #10023]
* Fri Aug 24 2001 - ro@suse.de
- removed /lib/security path from pam.d config file
* Thu Aug 16 2001 - bodammer@suse.de
- initscript and textfiles moved away from squid-2.3.STABLE4.dif
* Mon Aug 13 2001 - ro@suse.de
- changed neededforbuild <sp_libs> to <sp-devel>
* Thu May 10 2001 - bodammer@suse.de
- initscript fix: don't start squid in runlevel 2 [bug #7956]
* Wed May 09 2001 - mfabian@suse.de
- bzip2 sources
* Tue Apr 17 2001 - bodammer@suse.de
- initscript fix: check for running squid before creating cache-dir
* Thu Apr 05 2001 - bodammer@suse.de
- squid.conf: allow localhost access to squid by default
- initscript: ulimit -n 4096 added to increase filedescriptors
- cachemgr.cgi moved to doc/scripts
- build of Programming-Guide removed from specfile
* Fri Mar 30 2001 - bodammer@suse.de
- initscript-fix: $named for added for required startup
* Wed Mar 28 2001 - bodammer@suse.de
- new initscript more LSB conform
* Thu Mar 22 2001 - bodammer@suse.de
- new patch from www.squid-cache.org applied
* Fri Mar 16 2001 - kukuk@suse.de
- Fix bogus requires
* Thu Mar 15 2001 - ro@suse.de
- changed for openldap2
* Thu Mar 15 2001 - ro@suse.de
- fixed neededforbuild for openldap
* Tue Feb 13 2001 - bodammer@suse.de
- package squid23 renamed to squid
- specfile: Obsoletes squid2 and squid23 added
  Conflicts squid-beta added (instead of squid24)
- pam_auth: permissions set to sgid shadow
- build of doc/Programming-Guide fixed
* Fri Jan 19 2001 - bodammer@suse.de
- specfile fix: ulimit was missing and conflicts squid24 added
* Tue Dec 19 2000 - bodammer@suse.de
- squid.h patched to allow increase of available filedescriptors:
  set to 4096 at buildtime by "ulimit -n 4096" in spec-file
* Tue Dec 12 2000 - ro@suse.de
- use official tags for required-start
* Mon Dec 11 2000 - bodammer@suse.de
- error in initscript fixed
* Wed Dec 06 2000 - bodammer@suse.de
- Requires ldaplib added in specfile
- errors in README.SuSE fixed
* Tue Dec 05 2000 - bodammer@suse.de
- hno-patch by Henrik Nordstrom included
- Initscript now checks for a running squid
* Mon Dec 04 2000 - bodammer@suse.de
- new patches from www.squid-cache.org included
* Tue Nov 28 2000 - bodammer@suse.de
- Fix location of rcscript
* Fri Nov 24 2000 - bodammer@suse.de
- rcscript update
* Mon Nov 06 2000 - ro@suse.de
- fixed neededforbuild
* Sat Oct 28 2000 - kukuk@suse.de
- Fix need for build filelist
* Mon Sep 18 2000 - bodammer@suse.de
- initscript reload-option fixed
- more patches from www.squid-cache.org
* Mon Jul 24 2000 - bodammer@suse.de
- another patch from www.squid-cache.org added
* Fri Jul 21 2000 - bodammer@suse.de
- patch ftp_icon_not_found from www.squid-cache.org added
* Tue Jul 18 2000 - bodammer@suse.de
- update -> squid-2.3.STABLE4
* Mon Jun 26 2000 - bodammer@suse.de
- another patch from www.squid-cache.org added
* Tue May 23 2000 - bodammer@suse.de
- specfile-fix: installation of docu changed
- initscript fixed
* Thu May 18 2000 - bodammer@suse.de
- new patches ("Disk space over the limit") included
* Wed May 17 2000 - bodammer@suse.de
- update -> squid-2.3STABLE3
* Wed Apr 12 2000 - bodammer@suse.de
- logfile-rotation disabled in squid.conf to avoid interaction
  with logfile-compression configured in /etc/logfiles
* Mon Mar 13 2000 - bodammer@suse.de
- new patches from squid.nlanr.net included
* Fri Mar 03 2000 - bodammer@suse.de
- update -> squid-2.3STABLE2
* Wed Feb 23 2000 - bodammer@suse.de
- more patches from squid.nlanr.net included
- init-script fix: wait for squid to shutdown
- location of pid-file changed to /var/run
* Wed Feb 16 2000 - bk@suse.de
- initial squid2.3STABLE1 package by bodammer
